#include "Set.h"
#include <iostream>
using namespace std;

Set::Set():head(0L),current(0L){
} 

void Set::Destroy(Node *node){
    if (node){
       Destroy(node->getNextNode());
       delete node;
    }
}

Set::~Set(){
  if (head){
     Destroy(head);
  }	
} 

void Set::DeepCopy(const Set& set){
   Node *p=set.head;
   while (p){
      add(p->getValue());	   
      p= p->getNextNode(); 
   }
}
	
Set::Set(const Set& set):head(0L),current(0L){
   if (!set.head) return; // empty set
   DeepCopy(set);
   current=head;
} 

void Set::operator=(const Set& set){
  if (head){
     Destroy(head);
     head=current=0L;
  }	
  DeepCopy(set);
  current=head;
} 

bool Set::add(int value){
    if (!head){ // add to empty set
       head=current= new Node(value);
       head->setNextNode(0L);
       return true;
    } 
    Node *p= head,*q=head;
    while (p){
       if (value==p->getValue()) return false;
       if (value<p->getValue()) break;
       q=p;       
       p= p->getNextNode();
    }
    Node *n= new Node(value);
    if (p==q) // if we add to the front
       current=head=n;
    else    
       q->setNextNode(n);
    n->setNextNode(p);
    return true;    
}

bool Set::hasMoreElements()const{
    return (current!=0L) ;
}

int  Set::next() {
    int ret= current->getValue();
    if (current) current= current->getNextNode();
    return ret;    
} 
